/*
Timemachine
Copyright (c) 2006 Technische Universitaet Muenchen,
                   Technische Universitaet Berlin,
                   The Regents of the University of California
All rights reserved.


Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. Neither the names of the copyright owners nor the names of its
   contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// $Id: tm.h 104 2006-11-10 00:46:14Z gregor $

#ifndef TM_H
#define TM_H

#include <string>

class Storage;
extern Storage *storage;

class LogFile;
extern LogFile *log_file;

// from cmd_parser.cc
int parse_cmd(const char* cmd, FILE *outfp, Storage* s);
void cmd_parser_init(void);
void cmd_parser_finish(void);


/* Security margin for index system. The intervals stored in 
 * the IndexEntry classes begins IDX_PKT_SECUIRTY_MARGIN packets
 * (meassured thru avg. iat) before the timestamp of the first
 * packet. Why? Since we used have to convert between doubles and
 * timevals precision errors might occur which might lead to 
 * missed packets during a query. Furthermore I'm not entirely
 * sure how well the binary search works. I.E. this offset also 
 * helps the bin_search() during query */
#define IDX_PKT_SECURITY_MARGIN 8


#define IDX_AGGREGATE_COUNT 10


#endif
